<?php

if(function_exists('tep_catalog_href_link')){
	require_once("../includes/languages/german/modules/payment/secupay_ls_osc.php");
	require_once("../".DIR_WS_CLASSES . 'secupay_api.php');
	require_once("../sp_conf_ls.php");
} else {
	require_once(DIR_WS_CLASSES . 'secupay_api.php');
	require_once("sp_conf_ls.php");
}
#if(file_exists(DIR_WS_CLASSES . 'secupay_api.php')){
#}else{

class secupay_ls_osc {

	var $code, $title, $description, $enabled,
		$kontonummer,
		$blz,
		$history_id,
		$demo, $sp_log, $conf;

	function secupay_ls_osc() {
		// class constructor
		global $order;

		$this->code = 'secupay_ls_osc';
		$this->title = (function_exists('tep_catalog_href_link'))?MODULE_PAYMENT_SPLS_TEXT_TITLE."<br/><img alt='secupay logo' src='images/secupay_label_24.png'/>":MODULE_PAYMENT_SPLS_TEXT_TITLE;
		$this->sort_order = MODULE_PAYMENT_SPLS_SORT_ORDER;
		$this->enabled = strcmp(MODULE_PAYMENT_SPLS_STATUS, 'Ja') == 0 ? true : false;
		$this->sp_log=false;

		//Demo Modus
		if (strcmp(MODULE_PAYMENT_SPLS_SIMULATION_MODE, "Simulation") == 0) {
			$this->demo = true;
		} else {
			$this->demo = false;
		}

		if ((int) MODULE_PAYMENT_SPLS_ORDER_STATUS_ID > 0) {
			$this->order_status_success = MODULE_PAYMENT_SPLS_ORDER_STATUS_ID;
		}
		$this->conf =get_sp_conf_ls();

		$this->description = MODULE_PAYMENT_SPLS_TEXT_DESCRIPTION."<br/>Version ".$this->conf->modulversion.
			" - <a style='color:green;' href='https://connect.secupay.ag/' target='_blank'>secupay Login</a>".
			" - <a style='color:green;' href='http://www.secupay.ag/' target='_blank'>secupay Website</a>";

		if(MODULE_PAYMENT_SPLS_LOGGING == "Ja"){
			$this->sp_log=true;
		}
		$this->description.='<iframe frameborder="0" scrolling="auto" src="https://connect.secupay.ag/shopiframe.php?vertrag_id_ls='.MODULE_PAYMENT_SPLS_VERTRAG_ID.'&amp;shop='.$this->conf->shop.'&amp;shopversion='.urlencode(PROJECT_VERSION).'&amp;modulversion='.urlencode($this->conf->modulversion).'" marginwidth="0px" marginheight="0px" name="secupay_info" style="border:0px; display:block;width:98%;margin-top:3px;margin-bottom:3px;"></iframe>';

		secupay_log($this->sp_log,"secupay_ls_osc constructor php ".PHP_VERSION);
		secupay_log($this->sp_log,"Conf: " . json_encode($this->conf));
		secupay_log($this->sp_log,"Modus: " . MODULE_PAYMENT_SPLS_SIMULATION_MODE);
		secupay_log($this->sp_log,"Sort Order: " . MODULE_PAYMENT_SPLS_SORT_ORDER);
		secupay_log($this->sp_log,"Aktiv: " . MODULE_PAYMENT_SPLS_STATUS);
		secupay_log($this->sp_log,"Shopname: " . MODULE_PAYMENT_SPLS_SHOPNAME);
		secupay_log($this->sp_log,"Kuferschutz: " . MODULE_PAYMENT_SPLS_KAEUFERSCHUTZ);
		secupay_log($this->sp_log,"Zahlungsgarantie: " . MODULE_PAYMENT_SPLS_GUARANTEE);
		secupay_log($this->sp_log,"Order Status erfolg: " . MODULE_PAYMENT_SPLS_ORDER_STATUS_ID);

		$_SESSION['sp_logging']=false;
		if(MODULE_PAYMENT_SPLS_LOGGING=="Ja"){
			$_SESSION['sp_logging']=true;
		}
		if (is_object($order)){
			$this->update_status();
		}
	}

	function update_status() {
		global $order;
		secupay_log($this->sp_log,"update_status");

		if (($this->enabled == true) && ((int) MODULE_PAYMENT_SPLS_ZONE > 0)) {
			$check_flag = false;
			$check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_SPLS_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
			while ($check = tep_db_fetch_array($check_query)) {
				if ($check['zone_id'] < 1) {
					$check_flag = true;
					break;
				} elseif ($check['zone_id'] == $order->billing['zone_id']) {
					$check_flag = true;
					break;
				}
			}

			if ($check_flag == false) {
				$this->enabled = false;
			}
		}
	}

	function javascript_validation() {
		$js = 		' if (payment_value == "' . $this->code . '") { var ls_owner = document.getElementsByName("ls_owner")[0].value; var ls_nummer = document.getElementsByName("ls_number")[0].value; var ls_blz = document.getElementsByName("ls_blz")[0].value;' . 
			' if (ls_owner == ""  || ls_owner.length <2)  { error_message = error_message + "' . MODULE_PAYMENT_SPLS_TEXT_JS_LS_OWNER . '";error = 1;}' . 
			' if (ls_nummer.length <4) { error_message = error_message + "' . MODULE_PAYMENT_SPLS_TEXT_JS_LS_NUMBER . '"; error = 1; }'.
			' if (ls_blz.length <4) { error_message = error_message + "' . MODULE_PAYMENT_SPLS_TEXT_JS_LS_BLZ . '"; error = 1; }'.
			' if (error === 1) { alert(error_message); return false;}  }';
		return $js;
	}

	function selection() {
		secupay_log($this->sp_log,"selection");
		global $order;
		$vert=MODULE_PAYMENT_SPLS_VERTRAG_ID;
		$schutz="";
		$title = $this->title;

		if(MODULE_PAYMENT_SPLS_GUARANTEE == "Ja" && MODULE_PAYMENT_SPLS_KAEUFERSCHUTZ == "Ja"){
			$schutz="<a href=\"#\" onclick=\"window.open('https://connect.secupay.ag/kaeuferschutz.php?v=$vert',null,'width=500,height=260,scrollbars=no,location=no,directories=no,status=no,menubar=no,toolbar=no,resizable=no,dependent=no');return false;\" ><img alt=\"secupay.Kuferschutz\" style=\"border:0;float:right;position:absolute;margin-left:20px;\" src=\"images/secupay_100x100.png\" /></a>";
			$title=$this->title . "&nbsp;<a style=\"color:green;\" href=\"#\" onclick=\"window.open('https://connect.secupay.ag/kaeuferschutz.php?v=$vert',null,'width=500,height=260,scrollbars=no,location=no,directories=no,status=no,menubar=no,toolbar=no,resizable=no,dependent=no');return false;\">mit secupay K&auml;uferschutz</a>";
		}
		$selection = array('id' => $this->code, 'module' => $title,
			'fields' => array(
				array(	'title' => MODULE_PAYMENT_SPLS_TEXT_LASTSCHRIFT_OWNER,
				'field' => tep_draw_input_field('ls_owner', $order->billing['firstname'] . ' ' . $order->billing['lastname']).$schutz),
				array(	'title' => MODULE_PAYMENT_SPLS_TEXT_LASTSCHRIFT_NUMBER,
				'field' => tep_draw_input_field('ls_number')),
				array(	'title' => MODULE_PAYMENT_SPLS_TEXT_LASTSCHRIFT_BLZ,
				'field' => tep_draw_input_field('ls_blz')),
				array(	'title' => "",'field' => ""),
				array(	'title' => "",'field' => ""),
				array(	'title' => "",'field' => ""),
				array(	'title' => "",'field' => ""),
				array(	'title' => "",'field' => "")
			));

		secupay_log($this->sp_log,$selection);
		return $selection;
	}

	function check() {
		if (!isset($this->_check)) {
			$check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_SPLS_STATUS'");
			$this->_check = tep_db_num_rows($check_query);
		}
		secupay_log($this->sp_log,"check($this->_check)");
		return $this->_check;
	}

	function pre_confirmation_check() {
		secupay_log($this->sp_log,"pre_confirmation_check");
		$this->ls_number = stripslashes($_POST['ls_number']);
	}

	function confirmation() {
		global $order;
		secupay_log($this->sp_log,"conirmation");
		$confirmation = array('title' => $this->title,
			'fields' => array(
				array('title' => MODULE_PAYMENT_SPLS_TEXT_LASTSCHRIFT_OWNER, 'field' => $_POST['ls_owner']),
				array('title' => MODULE_PAYMENT_SPLS_TEXT_LASTSCHRIFT_NUMBER, 'field' => $this->ls_number),
				array('title' => MODULE_PAYMENT_SPLS_TEXT_LASTSCHRIFT_BLZ, 'field' => $_POST['ls_blz'])
			));


		if(MODULE_PAYMENT_SPLS_GUARANTEE =="Ja"){
			$cession= substr(MODULE_PAYMENT_SPLS_CESSION_MODE,-4,3) == "Sie" ? MODULE_PAYMENT_SPLS_CESSION : MODULE_PAYMENT_SPLS_CESSION_PERSONALLY ;
			$confirmation['fields'] = array_pad($confirmation['fields'], -(count($confirmation['fields']) + 1), array('title' => '', 'field' => $cession));
		}

		if(isset($order->delivery) && MODULE_PAYMENT_SPLS_GUARANTEE == "Ja" && MODULE_PAYMENT_SPLS_WARNDELIVERY == "Ja"){
			$differs =false;
			if($order->delivery['firstname'] !== $order->customer['firstname']) { $differs = true; }
			if($order->delivery['lastname'] !== $order->customer['lastname']) { $differs = true; }
			if($order->delivery['company'] !== $order->customer['company']) { $differs = true; }
			if($order->delivery['city'] !== $order->customer['city']) { $differs = true; }
			if($order->delivery['postcode'] !== $order->customer['postcode']) { $differs = true; }
			if($order->delivery['street_address'] !== $order->customer['street_address']) { $differs = true; }

			if($differs){
				$additional_messages = array('title' => MODULE_PAYMENT_SPLS_HINT, 'field' => MODULE_PAYMENT_SPLS_DELIVERY_HINT);
				$confirmation['fields'][]=$additional_messages;
			}
		}
		return $confirmation;
	}

	function process_button() {
		global $order, $currencies;		
		$process_button_string =
			tep_draw_hidden_field('ls_owner', $_POST['ls_owner']) .
			tep_draw_hidden_field('ls_number', $_POST['ls_number']) .
			tep_draw_hidden_field('summe_aus_button', number_format($order->info['total'] , 2, '.','')) .
			tep_draw_hidden_field('ls_blz', $_POST['ls_blz']);

		secupay_log($this->sp_log,"process_button", $_POST, "summe_aus_button: ". number_format($order->info['total'] * $currencies->get_value($currency), 2, '.', ''));

		return $process_button_string;
	}

	function format_raw($number, $currency_code = '', $currency_value = '') {
		global $currencies, $currency;

		if (empty($currency_code) || !$this->is_set($currency_code)) {
			$currency_code = $currency;
		}

		if (empty($currency_value) || !is_numeric($currency_value)) {
			$currency_value = $currencies->currencies[$currency_code]['value'];
		}

		return number_format(tep_round($number * $currency_value, $currencies->currencies[$currency_code]['decimal_places']), $currencies->currencies[$currency_code]['decimal_places'], '.', '');
	}

	function before_process() {
		global $order, $xtPrice;

		//Daten vorbereiten
		$next_order_id = $this->_get_next_order_id();
		$ls_number = stripslashes($_POST['ls_number']);
		$ls_owner = stripslashes($_POST['ls_owner']);
		secupay_log($this->sp_log,"before_process next_order_id $next_order_id");
		$_mwst_bug = 0;
		
		if (MODULE_PAYMENT_SPLS_MWST == "Ja") {
			$_mwst_bug = ($order->info['shipping_cost'] * (19 / 100));
		}

		secupay_log($this->sp_log,"mwst_bug $_mwst_bug");
		$amount = $this->format_raw($_REQUEST['summe_aus_button']);
		secupay_log($this->sp_log,"amount $amount");

		$dob_res = tep_db_query("select customers_dob from " . TABLE_CUSTOMERS . " where customers_id=" . $_SESSION['customer_id']);
		if ($dob_res && $dob_row = tep_db_fetch_array($dob_res)) {
			$daten['geburts_datum'] = $dob_row['customers_dob'];
		}

		$store_name=MODULE_PAYMENT_SPLS_SHOPNAME;

		if(empty($store_name)){
			$res_store_name = tep_db_query("select configuration_value from configuration where configuration_key='STORE_NAME'");
			$row_store_name = tep_db_fetch_array($res_store_name);
			$store_name = $row_store_name['configuration_value'];
		}
		$data = Array();
		$data['basket'] = json_encode(get_object_vars($order));
		$data['apikey'] = MODULE_PAYMENT_SPLS_VERTRAG_ID;
		$data['shop'] = "osc";
		$data['shopversion'] = PROJECT_VERSION;
		$data['modulversion'] = $this->conf->modulversion;	
		$data['amount'] = $amount*100;

		$data['apiversion'] ="1.0";

		$data['accountowner'] = addslashes($_POST['ls_owner']);
		$data['accountnumber'] = preg_replace("/\\D/","", addslashes($_POST['ls_number']));
		$data['bankcode'] = preg_replace("/\\D/","", addslashes($_POST['ls_blz']));

		$data['purpose'] = "Bestellung vom " . date("d.m.y", time()) . "|bei " . $store_name . "|Bei Fragen TEL 035955755055";
		if($this->demo){
			$data['demo']=1;
		}
		$data['firstname'] = $order->customer['firstname'];
		$data['lastname'] = $order->customer['lastname'];
		$data['street'] = $order->customer['street_address'];
		$data['zip'] = $order->customer['postcode'];
		$data['city'] = $order->customer['city'];
		$data['email'] = $order->customer['email_address'];

		$data['ip'] = $_SERVER['REMOTE_ADDR'];

		$secure_code= md5(MODULE_PAYMENT_SPLS_VERTRAG_ID . time());
		$data['secure_code'] = $secure_code;

		if(MODULE_PAYMENT_SPLS_BID == "Ja") {
			$data['status_uri'] = HTTP_SERVER.DIR_WS_CATALOG."secupay_status.php";
		}

		$this->kontonummer = $data['accountnumber'];
		$this->blz = $data['bankcode'];

		if(MODULE_PAYMENT_SPLS_GUARANTEE == "Ja"){
			$sp_api = new secupay_api($data,"debitguarantee","json");
		}else{
			$sp_api = new secupay_api($data,"debit","json");
		}

		secupay_log($this->sp_log,$data);
		$api_return = $sp_api->request();

		$log_amount = $amount *100;
		$this->history_id = $this->_prepare_trans_log(tep_db_input(json_encode($data)), tep_db_input(json_encode($api_return)),tep_db_input($api_return->transaction_id),$next_order_id,tep_db_input($api_return->msg),tep_db_input($api_return->status),$log_amount,$secure_code);

		if ($api_return->status != "201") { //Fehler
			$error = utf8_decode($api_return->msg_user);
			$payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error) . '&ls_owner=' . urlencode($_POST['ls_owner']) . '&ls_number=' . stripslashes($_POST['ls_number']) . '&ls_blz=' . stripslashes($_POST['ls_blz']);
			tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
		}
	}

	function after_process() {
		global $insert_id;
		secupay_log($this->sp_log, "after_process history_id: ",$this->history_id);
		secupay_log($this->sp_log,"after_process insert_id $insert_id");
		tep_db_query("update secupay_history_ls set ordernr = $insert_id where log_id = " . $this->history_id);
		$kto = substr($this->kontonummer,0,3). str_pad("",strlen($this->kontonummer)-6,"X") .substr($this->kontonummer,-3); 
		$blz =  $this->blz;
		$paymethod = "\n\nBankverbindung der Bestellung\n\nKontonummer: " . $kto . "\nBankleitzahl: " . $blz;
		if($this->demo == true){
			$paymethod .= MODULE_PAYMENT_SPLS_DEMO_HINT;
		}
		$sql_data_array = array('orders_id' => (int)$insert_id,
			'orders_status_id' => (int)$this->order_status_success, //(int)$order->info['order_status'],
			'date_added' => 'now()',
			'customer_notified' => '0',
			'comments' => $paymethod);

		tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);

		#	tep_db_query("update " . TABLE_ORDERS . " set comments='" . mysql_real_escape_string($paymethod) . "' where orders_id=$insert_id ");
		#		tep_db_query("insert into " . TABLE_ORDERS_STATUS_HISTORY . " (orders_id,orders_status_id,customer_notified,comments) values($insert_id, {$this->order_status_success},  '" . mysql_real_escape_string($paymethod) . "')");

		if ($this->order_status_success)
			tep_db_query("UPDATE " . TABLE_ORDERS . " SET orders_status='" . $this->order_status_success . "' WHERE orders_id='" . $insert_id . "'");
	}

	function get_error() {
		$fehler = $_GET['error'];
		secupay_log($this->sp_log,"get_error ($fehler)");
		$error = array('title' => MODULE_PAYMENT_SPLS_TEXT_ERROR, 'error' => stripslashes(urldecode($fehler)));
		return $error;
	}

	function install() {
		secupay_log($this->sp_log,"install");
		$pref="insert into " . TABLE_CONFIGURATION . " ( configuration_title,configuration_description, configuration_key, configuration_value,  configuration_group_id, sort_order,";

		if($this->conf->vertrag_id && is_string($this->conf->vertrag_id)){
			$vertrag_id_ls = trim($this->conf->vertrag_id);
		}

		$modus = $this->conf->modus =="live" ? "Produktivsystem" : "Simulation";
		$debug = $this->conf->debug ? 'Ja'	: 'Nein';
		$kaeuferschutz = $this->conf->kaeuferschutz ? 'Ja' : 'Nein';
		$zg 	= $this->conf->zahlungsgarantie? 'Ja' : 'Nein';
		$lw 	= $this->conf->lieferanschrift_warnung ? 'Ja' : 'Nein';
		$modul 	= $this->conf->modul;

		tep_db_query("$pref set_function, date_added) values ('".MODULE_PAYMENT_SPLS_STATUS_TITLE."','".MODULE_PAYMENT_SPLS_STATUS_DESC."', 'MODULE_PAYMENT_SPLS_STATUS', 'Ja', '6', '0', 'tep_cfg_select_option(array(\'Ja\', \'Nein\'), ', now())");
		tep_db_query("$pref date_added) values ('".MODULE_PAYMENT_SPLS_SORT_ORDER_TITLE."','".MODULE_PAYMENT_SPLS_SORT_ORDER_DESC."', 'MODULE_PAYMENT_SPLS_SORT_ORDER', '0',  '6', '0' , now())");
		tep_db_query("$pref date_added) values ('".MODULE_PAYMENT_SPLS_VERTRAG_ID_TITLE."','".MODULE_PAYMENT_SPLS_VERTRAG_ID_DESC."', '".MODULE_PAYMENT_SPLS_VERTRAG_ID."', '{$vertrag_id_ls}',  '6', '0' , now())");
		tep_db_query("$pref use_function, set_function, date_added) values ( '".MODULE_PAYMENT_SPLS_ZONE_TITLE."','".MODULE_PAYMENT_SPLS_ZONE_DESC."', 'MODULE_PAYMENT_SPLS_ZONE', '0',  '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
		tep_db_query("$pref set_function, use_function, date_added) values ('".MODULE_PAYMENT_SPLS_ORDER_STATUS_ID_TITLE."','".MODULE_PAYMENT_SPLS_ORDER_STATUS_ID_DESC."', 'MODULE_PAYMENT_SPLS_ORDER_STATUS_ID', '0',  '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");

		tep_db_query("$pref set_function, date_added) values ( '".MODULE_PAYMENT_SPLS_SIMULATION_MODE_TITLE."','".MODULE_PAYMENT_SPLS_SIMULATION_MODE_DESC."', 'MODULE_PAYMENT_SPLS_SIMULATION_MODE', '$modus', '6', '0', 'tep_cfg_select_option(array(\'Simulation\', \'Produktivsystem\'), ', now())");
		tep_db_query("$pref set_function, date_added) values ( '".MODULE_PAYMENT_SPLS_MWST_TITLE."','".MODULE_PAYMENT_SPLS_MWST_DESC."', 'MODULE_PAYMENT_SPLS_MWST', 'Nein', '6', '0', 'tep_cfg_select_option(array(\'Ja\', \'Nein\'), ', now())");
		tep_db_query("$pref set_function, date_added) values ( '".MODULE_PAYMENT_SPLS_LOGGING_TITLE."','".MODULE_PAYMENT_SPLS_LOGGING_DESC."', 'MODULE_PAYMENT_SPLS_LOGGING','$debug', '6', '0', 'tep_cfg_select_option(array(\'Ja\', \'Nein\'), ', now())");
		tep_db_query("$pref set_function, date_added) values ( '".MODULE_PAYMENT_SPLS_WARNDELIVERY_TITLE."','".MODULE_PAYMENT_SPLS_WARNDELIVERY_DESC."', 'MODULE_PAYMENT_SPLS_WARNDELIVERY', '$lw', '6', '0', 'tep_cfg_select_option(array(\'Ja\', \'Nein\'), ', now())");
		tep_db_query("$pref set_function, date_added) values ( '".MODULE_PAYMENT_SPLS_CESSION_MODE_TITLE."','".MODULE_PAYMENT_SPLS_CESSION_MODE_DESC."', 'MODULE_PAYMENT_SPLS_CESSION_MODE', 'Geschftlich (Anrede: Sie)', '6', '0', 'tep_cfg_select_option(array(\'Geschftlich (Anrede: Sie)\', \'Persnlich (Anrede: Du)\'), ', now())");
		tep_db_query("$pref date_added) values ('".MODULE_PAYMENT_SPLS_SHOPNAME_TITLE."','".MODULE_PAYMENT_SPLS_SHOPNAME_DESC."', 'MODULE_PAYMENT_SPLS_SHOPNAME', '',  '6', '0' , now())");
		tep_db_query("$pref set_function, date_added) values ('".MODULE_PAYMENT_SPLS_KAEUFERSCHUTZ_TITLE."','".MODULE_PAYMENT_SPLS_KAEUFERSCHUTZ_DESC."',  'MODULE_PAYMENT_SPLS_KAEUFERSCHUTZ', '$kaeuferschutz', '6', '0', 'tep_cfg_select_option(array(\'Ja\', \'Nein\'), ', now())");
		tep_db_query("$pref set_function, date_added) values ('".MODULE_PAYMENT_SPLS_GUARANTEE_TITLE."','".MODULE_PAYMENT_SPLS_GUARANTEE_DESC."',  'MODULE_PAYMENT_SPLS_GUARANTEE', '$zg', '6', '0', 'tep_cfg_select_option(array(\'Ja\', \'Nein\'), ', now())");
		tep_db_query("$pref set_function, date_added) values ('".MODULE_PAYMENT_SPLS_BID_TITLE."','".MODULE_PAYMENT_SPLS_BID_DESC."',  'MODULE_PAYMENT_SPLS_BID', 'Ja', '6', '0', 'tep_cfg_select_option(array(\'Ja\', \'Nein\'), ', now())");
		#tep_db_query("$pref date_added) values ('".MODULE_PAYMENT_SPLS_STATUS_TITLE."','".MODULE_PAYMENT_SPLS_STATUS_DESC."', 'MODULE_PAYMENT_SECUPAY_LS_tep_ALLOWED', '', '6', '0', now())");

		tep_db_query("drop table if exists secupay_history_ls");
		tep_db_query("create table secupay_history_ls (`log_id` int(10) unsigned not null auto_increment,
			`req_data` text,
			`ret_data` text,
			`payment_method` varchar(255) ,
			`transaction_id` int(10) unsigned default null,
			`ordernr` int(11) default null,
			`msg` varchar(255),
			`rank` int(10) default null,
			`status` int(11) default null,
			`amount` varchar(255) default null,
			`action` text,
			`secure_code` varchar(255),
			`created` datetime not null,
			`timestamp` timestamp,
			primary key  (`log_id`)) auto_increment=1");
	}

	function remove() {
		secupay_log($this->sp_log,"remove");
		tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "','MODULE_PAYMENT_SECUPAY_LS_OSC_ALLOWED')");

	}

	function keys() {
		$keys=array(
			'MODULE_PAYMENT_SPLS_STATUS',
			'MODULE_PAYMENT_SPLS_VERTRAG_ID',
			'MODULE_PAYMENT_SPLS_GUARANTEE',
			'MODULE_PAYMENT_SPLS_SORT_ORDER',
			'MODULE_PAYMENT_SPLS_KAEUFERSCHUTZ',
			'MODULE_PAYMENT_SPLS_WARNDELIVERY',
			'MODULE_PAYMENT_SPLS_CESSION_MODE',
			'MODULE_PAYMENT_SPLS_SHOPNAME',
			'MODULE_PAYMENT_SPLS_SIMULATION_MODE',
			'MODULE_PAYMENT_SPLS_LOGGING',
			'MODULE_PAYMENT_SPLS_ZONE',
			'MODULE_PAYMENT_SPLS_ORDER_STATUS_ID', 
			'MODULE_PAYMENT_SPLS_MWST',
			'MODULE_PAYMENT_SPLS_BID'
		);
		secupay_log($this->sp_log,"keys",$keys);
		return $keys;
	}

	//intern verwendete Methoden
	function _get_next_order_id() {
		$qry = tep_db_query('SELECT max(orders_id) + 1 next_id from ' . TABLE_ORDERS);
		$res = tep_db_fetch_array($qry);

		if (!$res['next_id']) {
			return 1;
		} else {
			return $res['next_id'];
		}
	}

	function _prepare_trans_log($req_data,$ret_data,$transaction_id,$ordernr,$msg,$status,$amount, $secure_code) {
		$sql = "insert into secupay_history_ls (req_data, ret_data,payment_method,transaction_id, ordernr, msg,rank,status,amount,action,secure_code,created)" .
			" values ('$req_data','$ret_data','{$this->code}','$transaction_id','$ordernr','$msg',0,'$status',$amount,'','$secure_code',NOW())";
		$qry = tep_db_query($sql);
		return tep_db_insert_id();
	}
}
