<?php
require('includes/application_top.php');

if (!tep_session_is_registered('customer_id')) {
	tep_redirect(tep_href_link(FILENAME_SHOPPING_CART));
}

// if the customer is not logged on, redirect them to the shopping cart page
if (!tep_session_is_registered('customer_id')) {
	tep_redirect(tep_href_link(FILENAME_SHOPPING_CART));
}

if (isset($HTTP_GET_VARS['action']) && ($HTTP_GET_VARS['action'] == 'update')) {
	$notify_string = '';

	if (isset($HTTP_POST_VARS['notify']) && !empty($HTTP_POST_VARS['notify'])) {
		$notify = $HTTP_POST_VARS['notify'];

		if (!is_array($notify)) {
			$notify = array($notify);
		}

		for ($i=0, $n=sizeof($notify); $i<$n; $i++) {
			if (is_numeric($notify[$i])) {
				$notify_string .= 'notify[]=' . $notify[$i] . '&';
			}
		}

		if (!empty($notify_string)) {
			$notify_string = 'action=notify&' . substr($notify_string, 0, -1);
		}
	}

	tep_redirect(tep_href_link(FILENAME_DEFAULT, $notify_string));
}


require(DIR_WS_LANGUAGES . $language . '/' . FILENAME_CHECKOUT_SUCCESS);
require (DIR_WS_CLASSES . 'payment.php');

$payment_modules = new payment($_SESSION['payment']);

// load the selected shipping module
require (DIR_WS_CLASSES . 'shipping.php');
$shipping_modules = new shipping($_SESSION['shipping']);

require (DIR_WS_CLASSES . 'order_total.php');
require (DIR_WS_CLASSES . 'order.php');
$order = new order();

$order_total_modules = new order_total();
$order_total_modules->process();

$breadcrumb->add(NAVBAR_TITLE_1);
$breadcrumb->add(NAVBAR_TITLE_2);


$global_query = tep_db_query("select global_product_notifications from " . TABLE_CUSTOMERS_INFO . " where customers_info_id = '" . (int) $customer_id . "'");
$global = tep_db_fetch_array($global_query);

if ($global['global_product_notifications'] != '1') {
	$orders_query = tep_db_query("select orders_id from " . TABLE_ORDERS . " where customers_id = '" . (int) $customer_id . "' order by date_purchased desc limit 1");
	$orders = tep_db_fetch_array($orders_query);

	$products_array = array();
	$products_query = tep_db_query("select products_id, products_name from " . TABLE_ORDERS_PRODUCTS . " where orders_id = '" . (int) $orders['orders_id'] . "' order by products_name");
	while ($products = tep_db_fetch_array($products_query)) {
		$products_array[] = array('id' => $products['products_id'],
			'text' => $products['products_name']);
	}
}

require(DIR_WS_INCLUDES . 'template_top.php');


tep_session_recreate();
if (!isset($_SESSION['iframe_link'])) {
	tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL'));
} else {
	$iframe = $_SESSION['iframe_link'];
	unset($_SESSION['iframe_link']);
}
?>
<div class="contentContainer">
  <div class="contentText">
		<link rel="stylesheet" type="text/css" href="stylesheet.css">
		<style type="text/css">
			.nav_right{
				height:700px;
			}
			.sp_logo{
				height:35px;
				_background-image: url('https://connect.secupay.ag/css/secupay-Logo-kleiner.png');
				background-image: url('images/sp_logo_10.png');
				background-position: 50% 50%;
				background-repeat: no-repeat;
				margin: 0 auto;
				bottom:-10px;
				z-index:2;
				position:relative;
			}
			.iframe_wrapper{
				height:340px;
				margin-top:50px;
				text-align:center;
			}
			#iframe_wrapper_center{
				border:1px solid #212121;
				margin: 0 auto;
				width: 449px;
			}
			#spiframe{
				width:449px;
				height:339px;
			}
			#fail_link a{
				font-size:normal;
				text-decoration:none;
				font-weight:bold;
				color:white;
			}
			#fail_link{
				background-color:#b55353;
				text-align:center;
			}
		</style>

		<div class="iframe_wrapper">
			<div class="sp_logo"></div>
			<div id="iframe_wrapper_center">
				<iframe id="spiframe" src="<?php echo($iframe); ?>" width="100%" height="750" name="_top" frameborder="0"></iframe>
				<div id='fail_link'>
					<a href="<?php echo(tep_href_link("secupay_checkout_failure.php", "CANCELED=1&ERRORCODE=0&ERROR=" . urlencode("Zahlungsvorgang abgebrochen."), "SSL", true, false)); ?> ">Abbruch</a>
				</div>
			</div>
		</div>
	</div>

	<div class="contentText">
	</div>
</div>

<?php
  require(DIR_WS_INCLUDES . 'template_bottom.php');
  require(DIR_WS_INCLUDES . 'application_bottom.php');
?>
